export rho,
    Cp,
    visc,
    therm_cond,
    therm_expand,
    compress,
    std_props

## Std props

function std_props(fluid::Fluid)
    ρ = fluid.ρ
end


## rho

function rho(P, T, fluid::Fluid)
    @error "Property not yet implemented for the fluid. - ρ"
    throw(NotImplementedError())
    return missing
end


## Cp

function Cp(P, T, fluid::Fluid)
    @error "Property not yet implemented for the fluid. - Cₚ"
    throw(NotImplementedError())
    return missing
end


## k

function therm_cond(P, T, fluid::Fluid)
    @error "Property not yet implemented for the fluid. - k"
    throw(NotImplementedError())
    return missing
end


# mu


function visc(P, T, fluid::Fluid)
    @error "Property not yet implemented for the fluid. - μ"
    throw(NotImplementedError())
    return missing
end








# function drho(P,T,fluid::Fluid)
#     return gradient((PT)->rho(PT[1],PT[2],fluid),[P,T])
# end

# drhodP(P,T,fluid::Fluid) = drho(P,T,fluid)[1]

# drhodT(P,T,fluid::Fluid) = drho(P,T,fluid)[2]

# # therm expand

# function therm_expand(P, T, fluid::Fluid)
#     # println("Vold")
#     # return -gradient(x -> rho(P, x, fluid), T)[1] / rho(P, T, fluid)
#     # println("Vnew")
#     return -drhodT(P,T,fluid)/rho(P,T,fluid)
# end


# ## compressibility

# function compress(P, T, fluid::Fluid)
#     # return Zygote.gradient(x -> rho(x, T, fluid), P)[1] / rho(P, T, fluid)
#     return drhodP(P,T,fluid)/rho(P,T,fluid)
# end



# Solid

## density

function rho(P, T, solid::Solid)
    # @error "Property not yet implemented for solid - ρ"
    # throw(NotImplementedError())
    # return missing
    return solid.ρ
end

## Cp

function Cp(P, T, solid::Solid)
    # @error "Property not yet implemented for solid - Cₚ"
    # throw(NotImplementedError())
    # return missing
    return solid.cₚ
end


function Cp(P, T, solid::CaCO3)
    return solid.cₚ
end

function Cp(P,T,solid::Hematite)
    A=93.43834
    B=108.3577
    C=-50.86447
    D=25.58683
    E=-1.611330
    t=T/1000.0
    CpM=A+B*t+C*t^2+D*t^3+E/(t^2)
    return CpM/159.688*1000.0
end

## therm cond

function therm_cond(P, T, solid::Solid)
    @error "Property not yet implemented for solid - k"
    throw(NotImplementedError())
    return missing
end






function drho(P,T,mat::Union{Fluid,Solid})
    try
        return gradient((PT)->rho(PT[1],PT[2],mat),[P,T])
    catch e
        return zeros(promote_type(eltype(P),eltype(T)),2)
    end
end

drhodP(P,T,mat::Union{Fluid,Solid}) = drho(P,T,mat)[1]
drhodT(P,T,mat::Union{Fluid,Solid}) = drho(P,T,mat)[2]


function therm_expand(P,T,mat::Union{Fluid,Solid})
    return -drhodT(P,T,mat)/rho(P,T,mat)
end

function compress(P,T,mat::Union{Fluid,Solid})
    return drhodP(P,T,mat)/rho(P,T,mat)
end


function dbeta(P,T,mat::Union{Fluid,Solid})
    try
        return gradient((PT)->therm_expand(PT[1],PT[2],mat),[P,T])
    catch e
        return zeros(promote_type(eltype(P),eltype(T)),2)
    end
end


dbetadT(P,T,mat::Union{Fluid,Solid}) = dbeta(P,T,mat)[2]




# # therm expand

# function therm_expand(P, T, fluid::Solid)
#     try
#         return -gradient(x -> rho(P, x, fluid), T)[1] / rho(P, T, fluid)
#     catch e
#         return zero(promote_type(eltype(P),eltype(T)))
#     end
# end


# ## compressibility

# function compress(P, T, fluid::Solid)
#     try
#         return gradient(x -> rho(x, T, fluid), P)[1] / rho(P, T, fluid)
#     catch e
#         return zero(promote_type(eltype(P),eltype(T)))
#     end
# end
