@testset "1-Hexadecene" begin

    ## Tests points taken from Khasashin et al. 2006

    PTs=[
        [0.1E6, 303.15],
        [0.1E6, 433.15],
        [100.0E6, 303.15],
        [100.0E6, 433.15],
        [30.0E6, 373.15]
    ]

    rhos_kha = [
        774.2,
        683.2,
        824.3,
        764.6,
        751.3
    ]
    Cps_kha = Float64[
        2173,
        2613,
        2148,
        2570,
        2381
    ]

    hex = Hexadecene()

    @testset "Density" begin
        @testset "P=$(P) Pa, T=$(T) K" for (i,(P,T)) in enumerate(PTs)
            @test rho(P,T,hex) ≈ rhos_kha[i] rtol=1E-3
        end
    end
    @testset "Specific Heat" begin
        @testset "P=$(P) Pa, T=$(T) K" for (i,(P,T)) in enumerate(PTs)
            @test Cp(P,T,hex) ≈ Cps_kha[i] rtol=5E-2
        end
    end






end
